1#!/bin/bash
2###############################################################################
3#
4# This build script is for running the OpenBMC builds as Docker containers.
5#
6###############################################################################
7#
8# Script Variables:
9#  build_scripts_dir  The path of the openbmc-build-scripts directory.
10#                     Default: The directory containing this script
11#  http_proxy         The HTTP address of the proxy server to connect to.
12#                     Default: "", proxy is not setup if this is not set
13#  WORKSPACE          Path of the workspace directory where some intermediate
14#                     files and the images will be saved to.
15#                     Default: "~/{RandomNumber}"
16#  num_cpu            Number of cpu's to give bitbake, default is total amount
17#                     in system
18#
19# Docker Image Build Variables:
20#  BITBAKE_OPTS       Set to "-c populate_sdk" or whatever other BitBake options
21#                     you'd like to pass into the build.
22#                     Default: "", no options set
23#  build_dir          Path where the actual BitBake build occurs inside the
24#                     container, path cannot be located on network storage.
25#                     Default: "/tmp/openbmc"
26#  distro             The distro used as the base image for the build image:
27#                     fedora|ubuntu
28#                     Default: "ubuntu"
29#  img_name           The name given to the target build's docker image.
30#                     Default: "openbmc/${distro}:${imgtag}-${target}-${ARCH}"
31#  img_tag            The base docker image distro tag:
32#                     ubuntu: latest|16.04|14.04|trusty|xenial
33#                     fedora: 23|24|25
34#                     Default: "latest"
35#  target             The target we aim to build:
36#                     evb-ast2500|palmetto|qemu|qemux86-64
37#                     romulus|s2600wf|witherspoon|zaius|tiogapass
38#                     Default: "qemu"
39#
40# Deployment Variables:
41#  obmc_dir           Path of the OpenBMC repo directory used as a reference
42#                     for the build inside the container.
43#                     Default: "${WORKSPACE}/openbmc"
44#  xtrct_small_copy_dir
45#                     Directory within build_dir that should be copied to
46#                     xtrct_path. The directory and all parents up to, but not
47#                     including, build_dir will be copied. For example, if
48#                     build_dir is set to "/tmp/openbmc" and this is set to
49#                     "build/tmp", the directory at xtrct_path will have the
50#                     following directory structure:
51#                     xtrct_path
52#                      | - build
53#                        | - tmp
54#                          ...
55#                     Can also be set to the empty string to copy the entire
56#                     contents of build_dir to xtrct_path.
57#                     Default: "deploy/images".
58#
59###############################################################################
60# Trace bash processing. Set -e so when a step fails, we fail the build
61set -xeo pipefail
62
63# Script Variables:
64build_scripts_dir=${build_scripts_dir:-"$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"}
65http_proxy=${http_proxy:-}
66WORKSPACE=${WORKSPACE:-${HOME}/${RANDOM}${RANDOM}}
67num_cpu=${num_cpu:-$(nproc)}
68
69# Docker Image Build Variables:
70build_dir=${build_dir:-/tmp/openbmc}
71distro=${distro:-ubuntu}
72img_tag=${img_tag:-latest}
73target=${target:-qemu}
74
75# Deployment variables
76obmc_dir=${obmc_dir:-${WORKSPACE}/openbmc}
77ssc_dir=${HOME}
78xtrct_small_copy_dir=${xtrct_small_copy_dir:-deploy/images}
79xtrct_path="${obmc_dir}/build/tmp"
80xtrct_copy_timeout="300"
81
82PROXY=""
83
84# Determine the architecture
85ARCH=$(uname -m)
86
87# Determine the prefix of the Dockerfile's base image
88case ${ARCH} in
89  "ppc64le")
90    DOCKER_BASE="ppc64le/"
91    ;;
92  "x86_64")
93    DOCKER_BASE=""
94    ;;
95  *)
96    echo "Unsupported system architecture(${ARCH}) found for docker image"
97    exit 1
98esac
99
100# Timestamp for job
101echo "Build started, $(date)"
102
103# If the obmc_dir directory doesn't exist clone it in
104if [ ! -d ${obmc_dir} ]; then
105  echo "Clone in openbmc master to ${obmc_dir}"
106  git clone https://github.com/openbmc/openbmc ${obmc_dir}
107fi
108
109# Make and chown the xtrct_path directory to avoid permission errors
110if [ ! -d ${xtrct_path} ]; then
111  mkdir -p ${xtrct_path}
112fi
113chown ${UID}:${GROUPS} ${xtrct_path}
114
115# Work out what build target we should be running and set BitBake command
116MACHINE=""
117case ${target} in
118  palmetto)
119    LAYER_DIR="meta-ibm/meta-palmetto"
120    ;;
121  witherspoon)
122    LAYER_DIR="meta-ibm/meta-witherspoon"
123    ;;
124  evb-ast2500)
125    LAYER_DIR="meta-evb/meta-evb-aspeed/meta-evb-ast2500"
126    ;;
127  s2600wf)
128    LAYER_DIR="meta-intel/meta-s2600wf"
129    ;;
130  zaius)
131    LAYER_DIR="meta-ingrasys/meta-zaius"
132    ;;
133  romulus)
134    LAYER_DIR="meta-ibm/meta-romulus"
135    ;;
136  qemu)
137    LAYER_DIR="meta-phosphor"
138    # MACHINE defaults to `qemuarm` in this layer, no change necessary
139    ;;
140  qemux86-64)
141    LAYER_DIR="meta-phosphor"
142    # MACHINE defaults to `qemuarm` in this layer, change to `qemux86-64`
143    MACHINE="qemux86-64"
144    ;;
145  tiogapass)
146    LAYER_DIR="meta-facebook/meta-tiogapass"
147    ;;
148  *)
149    exit 1
150    ;;
151esac
152
153BITBAKE_CMD="TEMPLATECONF=${LAYER_DIR}/conf source oe-init-build-env"
154
155# Configure Docker build
156if [[ "${distro}" == fedora ]];then
157
158  if [[ -n "${http_proxy}" ]]; then
159    PROXY="RUN echo \"proxy=${http_proxy}\" >> /etc/dnf/dnf.conf"
160  fi
161
162  Dockerfile=$(cat << EOF
163  FROM ${DOCKER_BASE}${distro}:${img_tag}
164
165  ${PROXY}
166
167  # Set the locale
168  RUN locale-gen en_US.UTF-8
169  ENV LANG en_US.UTF-8
170  ENV LANGUAGE en_US:en
171  ENV LC_ALL en_US.UTF-8
172
173  RUN dnf --refresh install -y \
174      bzip2 \
175      chrpath \
176      cpio \
177      diffstat \
178      findutils \
179      gcc \
180      gcc-c++ \
181      git \
182      make \
183      patch \
184      perl-bignum \
185      perl-Data-Dumper \
186      perl-Thread-Queue \
187      python-devel \
188      python3-devel \
189      SDL-devel \
190      socat \
191      subversion \
192      tar \
193      texinfo \
194      wget \
195      which \
196      iputils-ping
197
198  RUN grep -q ${GROUPS} /etc/group || groupadd -g ${GROUPS} ${USER}
199  RUN grep -q ${UID} /etc/passwd || useradd -d ${HOME} -m -u ${UID} -g ${GROUPS} ${USER}
200
201  USER ${USER}
202  ENV HOME ${HOME}
203  RUN /bin/bash
204EOF
205)
206
207elif [[ "${distro}" == ubuntu ]]; then
208
209  if [[ -n "${http_proxy}" ]]; then
210    PROXY="RUN echo \"Acquire::http::Proxy \\"\"${http_proxy}/\\"\";\" > /etc/apt/apt.conf.d/000apt-cacher-ng-proxy"
211  fi
212
213  Dockerfile=$(cat << EOF
214  FROM ${DOCKER_BASE}${distro}:${img_tag}
215
216  ${PROXY}
217
218  ENV DEBIAN_FRONTEND noninteractive
219
220  RUN apt-get update && apt-get install -yy \
221      build-essential \
222      chrpath \
223      debianutils \
224      diffstat \
225      gawk \
226      git \
227      libdata-dumper-simple-perl \
228      libsdl1.2-dev \
229      libthread-queue-any-perl \
230      locales \
231      python \
232      python3 \
233      socat \
234      subversion \
235      texinfo \
236      cpio \
237      wget \
238      iputils-ping
239
240  # Set the locale
241  RUN locale-gen en_US.UTF-8
242  ENV LANG en_US.UTF-8
243  ENV LANGUAGE en_US:en
244  ENV LC_ALL en_US.UTF-8
245
246  RUN grep -q ${GROUPS} /etc/group || groupadd -g ${GROUPS} ${USER}
247  RUN grep -q ${UID} /etc/passwd || useradd -d ${HOME} -m -u ${UID} -g ${GROUPS} ${USER}
248
249  USER ${USER}
250  ENV HOME ${HOME}
251  RUN /bin/bash
252EOF
253)
254fi
255
256# Create the Docker run script
257export PROXY_HOST=${http_proxy/#http*:\/\/}
258export PROXY_HOST=${PROXY_HOST/%:[0-9]*}
259export PROXY_PORT=${http_proxy/#http*:\/\/*:}
260
261mkdir -p ${WORKSPACE}
262
263cat > "${WORKSPACE}"/build.sh << EOF_SCRIPT
264#!/bin/bash
265
266set -xeo pipefail
267
268# Go into the OpenBMC directory, the build will handle changing directories
269cd ${obmc_dir}
270
271# Set up proxies
272export ftp_proxy=${http_proxy}
273export http_proxy=${http_proxy}
274export https_proxy=${http_proxy}
275
276mkdir -p ${WORKSPACE}/bin
277
278# Configure proxies for BitBake
279if [[ -n "${http_proxy}" ]]; then
280
281  cat > ${WORKSPACE}/bin/git-proxy << \EOF_GIT
282  #!/bin/bash
283  # \$1 = hostname, \$2 = port
284  PROXY=${PROXY_HOST}
285  PROXY_PORT=${PROXY_PORT}
286  exec socat STDIO PROXY:\${PROXY}:\${1}:\${2},proxyport=\${PROXY_PORT}
287EOF_GIT
288
289  chmod a+x ${WORKSPACE}/bin/git-proxy
290  export PATH=${WORKSPACE}/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:${PATH}
291  git config core.gitProxy git-proxy
292
293  mkdir -p ~/.subversion
294
295  cat > ~/.subversion/servers << EOF_SVN
296  [global]
297  http-proxy-host = ${PROXY_HOST}
298  http-proxy-port = ${PROXY_PORT}
299EOF_SVN
300fi
301
302# Source our build env
303${BITBAKE_CMD}
304
305# Change MACHINE name when given for build target
306if [[ -n "${MACHINE}" ]]; then
307  sed "s/^MACHINE\ ??=.*/MACHINE\ ??=\ \"${MACHINE}\"/" -i conf/local.conf
308fi
309
310# Custom BitBake config settings
311cat >> conf/local.conf << EOF_CONF
312BB_NUMBER_THREADS = "$(nproc)"
313PARALLEL_MAKE = "-j$(nproc)"
314INHERIT += "rm_work"
315BB_GENERATE_MIRROR_TARBALLS = "1"
316DL_DIR="${ssc_dir}/bitbake_downloads"
317SSTATE_DIR="${ssc_dir}/bitbake_sharedstatecache"
318USER_CLASSES += "buildstats"
319INHERIT_remove = "uninative"
320TMPDIR="${build_dir}"
321EOF_CONF
322
323# Kick off a build
324bitbake ${BITBAKE_OPTS} obmc-phosphor-image obmc-phosphor-debug-tarball
325
326# Copy internal build directory into xtrct_path directory
327if [[ ${xtrct_small_copy_dir} ]]; then
328  mkdir -p ${xtrct_path}/${xtrct_small_copy_dir}
329  timeout ${xtrct_copy_timeout} cp -r ${build_dir}/${xtrct_small_copy_dir}/* ${xtrct_path}/${xtrct_small_copy_dir}
330else
331  timeout ${xtrct_copy_timeout} cp -r ${build_dir}/* ${xtrct_path}
332fi
333
334if [[ 0 -ne $? ]]; then
335  echo "Received a non-zero exit code from timeout"
336  exit 1
337fi
338
339EOF_SCRIPT
340
341chmod a+x ${WORKSPACE}/build.sh
342
343# Give the Docker image a name based on the distro,tag,arch,and target
344img_name=${img_name:-openbmc/${distro}:${img_tag}-${target}-${ARCH}}
345
346# Build the Docker image
347docker build -t ${img_name} - <<< "${Dockerfile}"
348
349# If obmc_dir or ssc_dir are ${HOME} or a subdirectory they will not be mounted
350mount_obmc_dir="-v ""${obmc_dir}"":""${obmc_dir}"" "
351mount_ssc_dir="-v ""${ssc_dir}"":""${ssc_dir}"" "
352if [[ "${obmc_dir}" = "${HOME}/"* || "${obmc_dir}" = "${HOME}" ]];then
353mount_obmc_dir=""
354fi
355if [[ "${ssc_dir}" = "${HOME}/"* || "${ssc_dir}" = "${HOME}" ]];then
356mount_ssc_dir=""
357fi
358
359# Run the Docker container, execute the build.sh script
360docker run \
361--cap-add=sys_admin \
362--net=host \
363--rm=true \
364-e WORKSPACE=${WORKSPACE} \
365-w "${HOME}" \
366-v "${HOME}":"${HOME}" \
367${mount_obmc_dir} \
368${mount_ssc_dir} \
369--cpus="$num_cpu" \
370-t ${img_name} \
371${WORKSPACE}/build.sh
372
373# To maintain function of resources that used an older path, add a link
374ln -sf ${xtrct_path}/deploy ${WORKSPACE}/deploy
375
376# Timestamp for build
377echo "Build completed, $(date)"
378